;///////////////////////////////////////////////////////////////////////////////////////////////////
;/					    Musical Key Reference 1.1							   /
;/					Written by Donald Straney 2/13/03						   /
;/				Designed for the Z80/TI-86 graphing calculator					   /
;///////////////////////////////////////////////////////////////////////////////////////////////////

;///////////////////////////////////////DEFINITIONS/////////////////////////////////////////////////

#include "asm86.h"				;Required include files
#include "ti86asm2.inc"
#include "ti86ops.inc"

datacol equ 5					;Small cursor position for displaying data for each key
datarow equ 50

.org _asm_exec_ram				;Start at asm_exec_ram

;/////////////////////////////////////MAIN PROGRAM//////////////////////////////////////////////////

  nop							;Display shell title
  jp ProgStart

  .dw 0,Title

ProgStart:
  call _runindicoff				;Stupid thing serves no purpose here
Major:						;Go on to display major keys
  call _clrLCD
  ld hl,MajorTitle				;Display bar
  call DrawBar					
MN:							;Major natural keys
  call SClear					;Clear text from previous screens
  ld hl,KListN					;Load pointer to major key list data table
  ld c,$20						;Draw space for natural
  call DrawSelectChar				;Draw key list
KloopMN:
  call _getkey					;Check for keypress
  ld hl,KListN					;Load pointer to major key list data table
  cp kLog						;Is a?
  call z,SelectCharAMN				;If so, select first char and display from data table pointer, still intact
  cp kSin						;Is b?
  call z,SelectCharBMN				;If so, select second char
  cp kCos						;Is c?
  call z,SelectCharCMN				;If so, select third char
  cp kTan						;Is d?
  call z,SelectCharDMN				;If so, select fourth char
  cp kExpon						;Is e?
  call z,SelectCharEMN				;If so, select fifth char
  cp kLn						;Is f?
  call z,SelectCharFMN				;If so, select sixth char
  cp kEE						;Is g?
  call z,SelectCharGMN				;If so, select seventh char
  cp kExit						;Is exit?
  jp z,_clrScrn						;If so, end
  cp kVarx						;Is x-Var?
  jp z,Minor					;If so, display minor keys
  cp kGrMenu					;Is graph key?
  jr z,MF						;If so, go to major flat display
  jp KloopMN					;Continue through key loop
MF:							;Major flat keys
  call SClear					;Clear text from previous screens
  ld hl,KListF					;Load pointer to major flat key list data table
  ld c,$62						;Draw b for flat
  call DrawSelectChar				;Draw key list
KloopMF:
  call _getkey					;Check for keypress
  ld hl,KListF					;Load pointer to major flat key list data table
  cp kLog						;Is a?
  call z,SelectCharAMF				;If so, select third char and display from data table pointer, still intact
  cp kSin						;Is b?
  call z,SelectCharBMF				;If so, select seventh char
  cp kCos						;Is Cb?
  call z,SelectCharCMF				;If so, refer to B
  cp kTan						;Is d?
  call z,SelectCharDMF				;If so, select fourth char
  cp kExpon						;Is e?
  call z,SelectCharEMF				;If so, select sixth char
  cp kLn						;Is Fb?
  call z,SelectCharFMF				;If so, refer to E
  cp kEE						;Is g?
  call z,SelectCharGMF				;If so, select fifth char
  cp kExit						;Is exit?
  jp z,_clrScrn						;If so, end
  cp kVarx						;Is x-Var?
  jp z,Minor					;If so, display minor keys
  cp kGrMenu					;Is graph key?
  jr z,MS						;If so, go to major sharp display
  jp KloopMF					;Continue through key loop
MS:							;Major sharp keys
  call SClear					;Clear text from previous screens
  ld hl,KListS					;Load pointer to major sharp key list data table
  ld c,$23						;Draw # for sharp
  call DrawSelectChar				;Draw key list
KloopMS:
  call _getkey					;Check for keypress
  ld hl,KListS					;Load pointer to major sharp key list data table
  cp kLog						;Is a?
  call z,SelectCharAMS				;If so, select third char and display from data table pointer, still intact
  cp kLn						;Is b?
  call z,SelectCharFMS				;If so, select first char
  cp kCos						;Is c?
  call z,SelectCharCMS				;If so, select sixth char
  cp kTan						;Is d?
  call z,SelectCharDMS				;If so, select fourth char
  cp kEE						;Is e?
  call z,SelectCharGMS				;If so, select second char
  cp kSin						;Is B#?
  call z,SelectCharBMS
  cp kExpon
  call z,SelectCharEMS
  cp kExit						;Is exit?
  jp z,_clrScrn						;If so, end
  cp kVarx						;Is x-Var?
  jr z,Minor					;If so, display minor keys
  cp kGrMenu					;Is graph key?
  jp z,MN						;If so, go to major natural display
  jp KloopMS					;Continue through key loop

Minor:						;Display minor keys
  call _clrLCD
  ld hl,MinorTitle				;Display bar
  call DrawBar					
mN:							;Minor natural keys
  call SClear					;Clear text from previous screens
  ld hl,KListN					;Load pointer to minor key list data table
  ld c,$20						;Draw space for natural
  call DrawSelectChar				;Draw key list
KloopmN:
  call _getkey					;Check for keypress
  ld hl,KListN					;Load pointer to minor key list data table
  cp kLog						;Is a?
  call z,SelectCharAmN				;If so, select first char and display from data table pointer, still intact
  cp kSin						;Is b?
  call z,SelectCharBmN				;If so, select second char
  cp kCos						;Is c?
  call z,SelectCharCmN				;If so, select third char
  cp kTan						;Is d?
  call z,SelectCharDmN				;If so, select fourth char
  cp kExpon						;Is e?
  call z,SelectCharEmN				;If so, select fifth char
  cp kLn						;Is f?
  call z,SelectCharFmN				;If so, select sixth char
  cp kEE						;Is g?
  call z,SelectCharGmN				;If so, select seventh char
  cp kExit						;Is exit?
  jp z,_clrScrn						;If so, end
  cp kVarx						;Is x-Var?
  jp z,Major					;If so, display major keys
  cp kGrMenu					;Is graph key?
  jr z,mF						;If so, go to minor flat display
  jp KloopmN					;Continue through key loop
mF:							;Minor flat keys
  call SClear					;Clear text from previous screens
  ld hl,KListF					;Load pointer to minor flat key list data table
  ld c,$62						;Draw b for flat
  call DrawSelectChar				;Draw key list
KloopmF:
  call _getkey					;Check for keypress
  ld hl,KListF					;Load pointer to minor flat key list data table
  cp kLog						;Is a?
  call z,SelectCharAmF				;If so, select fifth char and display from data table pointer, still intact
  cp kSin						;Is b?
  call z,SelectCharBmF				;If so, select seventh char
  cp kCos						;Is Cb?
  call z,SelectCharCmF				;If so, refer to B
  cp kEE						;Is g?
  call z,SelectCharGmF				;If so, select second char
  cp kTan						;Is d?
  call z,SelectCharDmF				;If so, select fourth char
  cp kExpon						;Is e?
  call z,SelectCharEmF				;If so, select sixth char
  cp kLn						;Is Fb?
  call z,SelectCharFmF				;If so, refer to E
  cp kExit						;Is exit?
  jp z,_clrScrn						;If so, end
  cp kVarx						;Is x-Var?
  jp z,Major					;If so, display major keys
  cp kGrMenu					;Is graph key?
  jr z,mS						;If so, go to minor sharp display
  jp KloopmF					;Continue through key loop
mS:							;Minor sharp keys
  call SClear					;Clear text from previous screens
  ld hl,KListS					;Load pointer to minor sharp key list data table
  ld c,$23						;Draw # for flat
  call DrawSelectChar				;Draw key list
KloopmS:
  call _getkey					;Check for keypress
  ld hl,KListS					;Load pointer to minor sharp key list data table
  cp kLog						;Is a?
  call z,SelectCharAmS				;If so, select third char and display from data table pointer, still intact
  cp kEE						;Is b?
  call z,SelectCharGmS				;If so, select first char
  cp kCos						;Is c?
  call z,SelectCharCmS				;If so, select sixth char
  cp kTan						;Is d?
  call z,SelectCharDmS				;If so, select fourth char
  cp kLn						;Is e?
  call z,SelectCharFmS				;If so, select second char
  cp kSin						;Is B#?
  call z,SelectCharBmS
  cp kExpon
  call z,SelectCharEmS
  cp kExit						;Is exit?
  jp z,_clrScrn						;If so, end
  cp kVarx						;Is x-Var?
  jp z,Major					;If so, display major keys
  cp kGrMenu					;Is graph key?
  jp z,mN						;If so, go to minor natural display
  jp KloopmS					;Continue through key loop

;/////////////////////////////COMMONLY USED ROUTINES AND RESOURCES//////////////////////////////////

SelectCharAMN:					;Set up registers for calling SelectChar
  ld b,0
  ld de,AMjN
  call SelectChar
  ret

SelectCharBMN:
  ld b,3
  ld de,BMjN
  call SelectChar
  ret

SelectCharCMN:
  ld b,6
  ld de,CMjN
  call SelectChar
  ret

SelectCharDMN:
  ld b,9
  ld de,DMjN
  call SelectChar
  ret

SelectCharEMN:
  ld b,12
  ld de,EMjN
  call SelectChar
  ret

SelectCharFMN:
  ld b,15
  ld de,FMjN
  call SelectChar
  ret

SelectCharGMN:
  ld b,18
  ld de,GMjN
  call SelectChar
  ret



SelectCharFMS:
  ld b,0
  ld de,FMjS
  call SelectChar
  ret

SelectCharCMS:
  ld b,3
  ld de,CMjS
  call SelectChar
  ret

SelectCharGMS:
  ld b,6
  ld de,GMjS
  call SelectChar
  ret

SelectCharDMS:
  ld b,9
  ld de,DMjS
  call SelectChar
  ret

SelectCharAMS:
  ld b,12
  ld de,AMjS
  call SelectChar
  ret

SelectCharEMS:
  ld b,15
  ld de,EMjS
  call SelectChar
  ret

SelectCharBMS:
  ld b,18
  ld de,BMjS
  call SelectChar
  ret


SelectCharBMF:		
  ld b,0
  ld de,BMjF
  call SelectChar
  ret

SelectCharEMF:
  ld b,3
  ld de,EMjF
  call SelectChar
  ret

SelectCharAMF:
  ld b,6
  ld de,AMjF
  call SelectChar
  ret

SelectCharDMF:
  ld b,9
  ld de,DMjF
  call SelectChar
  ret

SelectCharGMF:
  ld b,12
  ld de,GMjF
  call SelectChar
  ret

SelectCharCMF:
  ld b,15
  ld de,CMjF
  call SelectChar
  ret

SelectCharFMF:
  ld b,18
  ld de,FMjF
  call SelectChar
  ret




SelectCharAmN:
  ld b,0
  ld de,AMnN
  call SelectChar
  ret

SelectCharBmN:
  ld b,3
  ld de,BMnN
  call SelectChar
  ret

SelectCharCmN:
  ld b,6
  ld de,CMnN
  call SelectChar
  ret

SelectCharDmN:
  ld b,9
  ld de,DMnN
  call SelectChar
  ret

SelectCharEmN:
  ld b,12
  ld de,EMnN
  call SelectChar
  ret

SelectCharFmN:
  ld b,15
  ld de,FMnN
  call SelectChar
  ret

SelectCharGmN:
  ld b,18
  ld de,GMnN
  call SelectChar
  ret



SelectCharFmS:
  ld b,0
  ld de,FMnS
  call SelectChar
  ret

SelectCharCmS:
  ld b,3
  ld de,CMnS
  call SelectChar
  ret

SelectCharGmS:
  ld b,6
  ld de,GMnS
  call SelectChar
  ret

SelectCharDmS:
  ld b,9
  ld de,DMnS
  call SelectChar
  ret

SelectCharAmS:
  ld b,12
  ld de,AMnS
  call SelectChar
  ret

SelectCharEmS:
  ld b,15
  ld de,EMnS
  call SelectChar
  ret

SelectCharBmS:
  ld b,18
  ld de,BMnS
  call SelectChar
  ret



SelectCharBmF:		
  ld b,0
  ld de,BMnF
  call SelectChar
  ret

SelectCharEmF:
  ld b,3
  ld de,EMnF
  call SelectChar
  ret

SelectCharAmF:
  ld b,6
  ld de,AMnF
  call SelectChar
  ret

SelectCharDmF:
  ld b,9
  ld de,DMnF
  call SelectChar
  ret

SelectCharGmF:
  ld b,12
  ld de,GMnF
  call SelectChar
  ret

SelectCharCmF:
  ld b,15
  ld de,CMnF
  call SelectChar
  ret

SelectCharFmF:
  ld b,18
  ld de,FMnF
  call SelectChar
  ret

SelectChar:						;Show box around selected char and data routine for char (inputs: de=location of data string, b=cursor col)
  push bc						;Save bc, destroyed by block copy
  call SClear					;Clear lower screen
  call DrawSelectChar				;Draw key list again
  ld a,datarow					;Position small cursor for displaying data
  ld (_penRow),a
  ld a,datacol
  ld (_penCol),a
  ld h,d						;Transfer de to hl, to display text
  ld l,e
  call _vputs					;Display data pointed to by hl
  ld a,3						;Position cursor to cover up letter with box char
  ld (_curRow),a
  pop bc						;Restore bc
  ld a,b
  ld (_curCol),a
  ld a,$df						;Display black box
  call _putc
  ld a,(_curCol)					;Move cursor back one space to display inverse char
  dec a
  ld (_curCol),a
  set textInverse,(iy+textflags)		;Draw inverse
  ld a,(de)						;Get first char in string
  call _putc					;Display char inverse
  res textInverse,(iy+textflags)		;Restore to normal draw
  ret							;Return

SClear:
  push hl
  ld hl,$fd40					;Start screen clear about 20 lines down
ClearLoop:
  ld (hl),0						;Clear selected byte of screen
  ld a,h						;Test first byte of pointer for end-of-screen
  cp $ff
  jr z,CpNext					;If first byte matches end-of-screen number, test second byte
  jr IncHl						;Otherwise clear to next screen byte
CpNext:
  ld a,l						;Is second byte at end-of-screen too?
  cp $ff
  jr z,EndCLoop					;If it is, end loop
IncHl:						;Otherwise, clear next 8 pixels
  inc hl						;Point to next byte on screen
  jr ClearLoop
EndCLoop:
  pop hl
  ret							;Return

DrawBar:						;Draws title bar
  push hl						;Save hl with pointer to text
  ld hl,Bardata					;Set copy from pointer to title bar data
  ld de,$fc00					;Set copy to pointer to beginning of screen
  ld bc,112						;Set to copy 112 bytes-7 rows
  ldir						;Copy
  pop hl						;Restore hl
  set 3,(iy+5)					;Set for inverse text draw for title bar text
  xor a
  ld (_penRow),a					;Set to start text on 1st row
  ld a,25						;SET STARTING COLUMN FOR TITLE BAR TEXT
  ld (_penCol),a					;Set to start text on column defined by user
  call _vputs					;Draw title bar text
  res 3,(iy+5)					;Set back to normal text draw
  ret							;Return

DrawSelectChar:					;Draw list of keys
  ld a,1						;Draw b for flat, # for sharp, nothing for natural
  ld (_curRow),a
  ld a,10
  ld (_curCol),a
  ld a,c
  call _putc
  ld a,3
  ld (_curRow),a					;Set cursor position
  push hl
  xor a						;Clear a for use as screen pointer
DSLoop:
  ld (_curCol),a
  push af
  ld a,(hl)						;Display char
  call _putc
  pop af
  inc hl						;Point to next char
  add a,3						;Increment cursor
  cp 21						;Is at end?
  jr nz,DSLoop					;If not, loop
  pop hl
  ret    						;Else, return

Title: .db "Musical key reference",0	;Shell title

KListN:    .db "A"				;Data string table for major natural keys
		 .db "B"
		 .db "C"
		 .db "D"
		 .db "E"
		 .db "F"
		 .db "G"

KListF:    .db "B"				;Data string table for major flat keys
		 .db "E"
		 .db "A"
		 .db "D"
		 .db "G"
		 .db "C"
		 .db "F"

KListS:    .db "F"				;Data string table for major sharp keys
		 .db "C"
		 .db "G"
		 .db "D"
		 .db "A"
		 .db "E"
		 .db "B"

AMjN: .db "A: F,C,G#, F# rel minor",0	;Major natural data strings
BMjN: .db "B: F,C,G,D,A#, G# rel minor",0
CMjN: .db "C: No #, A rel minor",0
DMjN: .db "D: F,C#, B rel minor",0
EMjN: .db "E: F,C,G,D#, C# rel minor",0
FMjN: .db "F: Bb, D rel minor",0
GMjN: .db "G: F#, E rel minor",0

AMjS: .db "A#: See Bb",0		;Major sharp data strings
BMjS: .db "B#: See C",0
CMjS: .db "C#: F,C,G,D,A,E,"
.db "B#, Bb rel minor",0
DMjS: .db "D#: See Eb",0
EMjS: .db "E#: See F",0
FMjS: .db "F#: F,C,G,D,A,E#, D# rel minor",0
GMjS: .db "G#: See Ab",0

AMjF: .db "Ab: B,E,A,Db, F rel minor",0	;Major flat data strings
BMjF: .db "Bb: B,Eb, G rel minor",0
CMjF: .db "Cb: See B",0
DMjF: .db "Db: B,E,A,D,Gb, Bb rel minor",0
EMjF: .db "Eb: B,E,Ab, C rel minor",0
FMjF: .db "Fb: See E",0
GMjF: .db "Gb: B,E,A,D,G,Cb, Eb rel minor",0

AMnN: .db "a: No #, C rel major",0		;Minor natural data strings
BMnN: .db "b: F,C#, D rel major",0
CMnN: .db "c: B,E,Ab, Eb rel major",0
DMnN: .db "d: Bb, F rel major",0
EMnN: .db "e: F#, G rel major",0
FMnN: .db "f: B,E,A,Db, Ab rel major",0
GMnN: .db "g: B,Eb, Bb rel major",0

AMnS: .db "a#: See bb",0	;Minor sharp data strings
BMnS: .db "b#: See c",0
CMnS: .db "c#: F,C,G,D#, E rel major",0
DMnS: .db "d#: F,C,G,D,A,E#, F# rel major",0
EMnS: .db "e#: See f",0
FMnS: .db "f#: F,C,G#, A rel major",0
GMnS: .db "g#: F,C,G,D,A#, B rel major",0

AMnF: .db "ab: See g#",0		;Minor flat data strings
BMnF: .db "bb: B,E,A,D,Gb, Db rel major",0
CMnF: .db "cb: See b",0
DMnF: .db "db: See c#",0
EMnF: .db "eb: B,E,A,D,G,Cb, Gb rel major",0
FMnF: .db "fb: See e",0
GMnF: .db "gb: See f#",0

MajorTitle: .db "Key Reference: Major",0
MinorTitle: .db "Key Reference: Minor",0

Bardata: .db 00011111b				;Title bar data-7 lines
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111000b

	   .db 00111111b			
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111100b

	   .db 00111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111100b

	   .db 01111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111110b

	   .db 01111111b				
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111110b

	   .db 01111111b				
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111110b

	   .db 11111111b				
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b
	   .db 11111111b


.end
END